%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                                         %
%%   SATBILISATION ET RELANCE MACROECONOMIQUES POST COVID-19 DANS LA CEMAC %
%%                                                                         %
%%        Quels instruments pour quels effets dans un modle DSGE ?        %
%%                                                                         %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% CE MODELE MULTI-PAYS AVEC CHOCS REGIONAUX ET GLOBAUX SE PROPOSE D'ANALYSER LES FACTEURS DU RETOUR AUX CONDITIONS AYANT PREVALUES AVANT LA PANDEMIE DU COVID-19 DANS LA CEMAC
%% LA CEMAC EST MODELISEE COMME UNE ECONOMIE EN SURLIQUIDITE, IMPUTABLE AUX EFFETS DES RESSOURCES PETROLIERES A TRAVERS LES AVOIRS EXTERIEURS
%% LA MODELISATION DES TROIS AUTRES BLOCS EST FAITE DE MANIERE SYMETRIQUE SUIVANT UN DSGE CANONIQUE

%% LE MODELE REPLIQUE DANS UN PREMIER TEMPS LES EFFETS DE CETTE PANDEMIE, EN METTANT PARTICULIEREMENT L'ACCENT SUR LEUR PERSISTANCE
%% L'HYPOTHESE DE BASE EST QUE L'IMPACT DE CETTE PANDEMIE AURAIT TROIS CANAUX DE TRANSMISSION DANS LA CEMAC
%% *** LE PREMIER CANAL EST LIE A LA CONTRACTION DE LA DEMANDE EXTERIEURE DE LA CHINE, DE L'EUROPE ET DES USA
%% *** LE DEUXIEME DECOULE DE LA CONTRACTION DES COURS DU PETROLE DU FAIT DE LA BAISSE DE LA DEMANDE LIEE A CETTE RESSOURCE NATURELLE
%% *** LE TROISIEME CANAL EST UN EFFET DOMESTIQUE LIE AUX MESURES DE CONFINEMENT DANS LA ZONE

%% DANS UN DEUXIEME TEMPS, EN SUPPOSANT LE SYSTEME STABILISE, LES INSTRUMENTS MONETAIRE ET BUDGETAIRE SONT MIS EN OEUVRE EN VUE DU RETOUR AUX CONDITIONS INITIALES
%% LES REACTIONS A QUATRE TYPES D'INSTRUMENTS SONT ANALYSEES A SAVOIR 
%% *** LA MONNAIE DOMESTIQUE (LE TIAO, L'AMPLITUDE DU CORRIDOR, LE TIMP, LES COEFFICIENTS DE RESERVES, LE COLLATERAL)
%% *** LES DEPENSES PUBLIQUES DOMESTIQUES FINANCEES SUR ENDETTEMENT (INTERIEUR ET EXTERIEUR)
%% *** LA MONNAIE ETRANGERE (TAUX DIRECTEURS)
%% *** LES DEPENSES PUBLIQUES ETRANGERES


var C IB PI MH N NI W K IR RK IL IC THETAB MC Y YH A MUTR MU TR MUER QF LFI CL LFW I LF LB D ID ERTR T G B IM BC BH BS
CR CNR TAXC TAXW PHI Q S PIF PIH IRS PIS YS COVID19 KO NO WO YO PO AO AEX TCE;

varexo epsIR epsA epsMU epsTHETAB epsN epsCR epsCNR epsTAXC epsTAXW epsG epsBH epsBS epsPO epsAO epsCL epsS epsQ epsPIF epsYS epsIS epsIRS epsCOVID19; 


parameters sig beta etaN kappaW delta omicronK theta phi_F alpha phiC2 etaD phiC1 phi1 phi2 khi phipi phiy phiER phiER1 phi etaX nu 
rhoA rhoG rhoMU theta0 h omega ksi tau rhoAEX
m covid2 covid3 covid5 covid6 covid7 rhoCOVID19 rhotaxc rhotaxw txc txw rhoBH rhoBS by bc bh
alphaPHI thetaF lamdaF covid4 eta hs covid1 thetaS lamdaS khiS phipiS phiyS
deltaO alphaO gammaO rhoPO rhoAO

% ETAT STATIONNAIRE

IDss IBss Css Wss ILss RKss IRss MUTRss MUERss MUss ERTRss TRss Dss IMss Nss LFss Iss LBss Yss Kss Tss Gss BCss Bss MHss PIss THETABss
ICss Ass Pss TCEss
CRss CNRss TAXCss TAXWss PISss BHss BSss
POss NOss WOss YOss KOss AOss AEXss;

sig=0.18; beta=0.91; etaN=1.8; etaX=0.15; nu=0.9; kappaW=0.47; delta=0.025; omicronK=18; theta=10; phi_F=65; alpha=0.3; phiC2=7.5; etaD=0.02; phiC1=0.35; 
phi1=0.02; phi2=0.2; khi=0.92; phipi=1.5; phiy=0.1; phiER=0.4; phiER1=0.85; phi=0.2; rhoA=0.95; rhoG=0.95; rhoMU=0.95; theta0=0.01; h=0.86; omega=0.67; ksi=0.33;
m=0.35; rhotaxc=0.8; rhotaxw=0.8; rhoBH=0.9; rhoBS=0.9; txc=0; tau=0.6; txw=0; by=0.335; bh=0.229; bc=0.06; bs=0.765; 
alphaPHI=0.6; thetaF=0.9; lamdaF=0.4; eta=0.2; hs=0.87; covid1=2; thetaS=0.93; lamdaS=0.3; phiyS=0.5; khiS=0.85; phipiS=1.5;
deltaO=0.3; alphaO=0.01; rhoPO=0.8; gammaO=0.8; rhoAO=0.7; rhoAEX=0.8; AEXss=8.8;

rhoCOVID19=0; covid1=0;covid2=0; covid3=0; covid4=0; covid6=0; covid5=0; covid7=0;  
%%rhoCOVID19=0.85; rho1COVID19=0; covid1=2; covid2=0.75; covid3=2.1; covid4=0.33; covid5=1.6; covid6=0.8;

Yss=4.7; IDss=5; IBss=6; ILss=0.13; MUss=0.1; ERTRss=5.99; IMss=0.001; Wss=10.7; PIss=0.0075; IRss=0.008625; Ass=1.03; Pss=1; Nss=0.33;
CRss=1.8; CNRss=1.02; TAXCss=0.5; TAXWss=0.73; PISss=0.5; POss=1; AOss=1.03; YOss=0.94; AEXss=8.8; TCEss=0.5;

%Css=3.8987; Gss=0.94; Iss=1.41; Kss=56.4; MUERss=1.7119; RKss=6.8083; MUTRss=1.8119; Dss=2.1150; TRss=3.8321; LFss=3.0696; 
%LBss=4.7867; BCss=0.846; Tss=1.222; MHss=1.5; Bss=1.175; THETABss=0.0226; ICss=0.0315; ICss=0.0315;

Css=0.8295*Yss;//Css=(1-phi)*Yss-delta*Kss
Gss=phi*Yss;
Iss=0.3*Yss;//Iss=delta*Kss
Kss=(1/delta)*Iss;
MUERss=((1+IMss)+phiC1-(1+IRss))/phi2;
RKss=((1+IBss)-(1-delta))*(1+ILss);
MUTRss=MUss+MUERss;
//ERTRss=MUERss/MUTRss;
//Dss=(etaX*(1-nu)*(Css^(1/sig)*(1+IBss)))/(IBss-IDss);
Dss=0.45*Yss;
TRss=(MUss+MUERss)*Dss;
//Wss=((1-alpha)/alpha)*(Kss*((beta^(-1))-(1-delta))*(1+ILss))/(Nss*kappaW*(beta^(-1)));
//Nss=1-(etaN*(Css^(1/sig))/Wss);
LFss=kappaW*Wss*Nss+Iss;
LBss=LFss-(1-MUTRss)*Dss;
//BCss=MHss+Dss;
BCss=0.18*Yss;
//Tss=Gss+IMss*TRss+IBss*BCss-IRss*LBss;
Tss=0.14*Yss;
%%Tss=TAXCss+TAXWss;
MHss=etaX*nu*(Css^(1/sig))/(1-beta);
Bss=0.25*Yss;
THETABss=theta0*(LBss/Dss);
ICss=(1+IRss)*(1+THETABss)-1;
Bss=by*Yss;
BCss=bc*Bss;
BSss=bs*Bss;
BHss=bh*Bss;
KOss=alphaO*POss*YOss/gammaO;
NOss=(YOss/(AOss*(KOss)^gammaO))^(1/(1-gammaO));
WOss=(1-alphaO)*(1-gammaO)*POss*YOss/NOss;
%%Nss=tau*NIss+(1-tau)*NOss;


model;

%% OPEN ECONOMY RELATIONS

%% *** LAW OF ONE PRICE GAP 																								  	(1)
PHI=-(Q+(1-alphaPHI)*S);

%%*** TERMS OF TRADE WITH MEASUREMENT ERROR    																				  	(2)
S=PIF-PIH+epsS;

%%*** UNCOVERED INTEREST PARITY CONDITION WITH PREMIUM RISK																		(3)
%%Q(1)=-((IR-PI(1))-(IRS-PIS(1)))+epsQ;
Q=-((IR(-1)-PI)-(IRS(-1)-PIS))+epsQ(-1);

%%*** DOMESTIC INFLATION																										(4)
//%%PIH=beta*(1-thetaH)*PIH(1)+thetaH*PIH(-1)+lamdaH*MC+epsPIH;

%%*** IMPORT INFLATION																											(5)
PIF=beta*(1-thetaF)*PIF(1)+thetaF*PIF(-1)+lamdaF*PHI+covid4*COVID19(-1)+epsPIF;

%%*** OVERALL INFLATION																											(6)
PI=(1-alphaPHI)*PIH+alphaPHI*PIF;

%%*** FIRMS MARGINAL COST																										(7)
//%%MC=(sig/(1-h))*(C-h*C(-1))+rho*Y+alphaPHI-(1-rho)*A;

%%*** INTERNATIONAL RISK SHARING CONDITION																						(8)
%C-h*C(-1)=(C(1)-h*C)-((1-h)/sig)*(IR-PI(1));

%%*** GOODS MARKET CLEARING CONDITION																							(9)
Y=(2-alphaPHI)*alphaPHI*eta*S+(1-alphaPHI)*C+alphaPHI*eta*PHI+G+delta*I+alphaPHI*YS;
%Yss*Y*(1-phi)=Css*C+delta*Kss*I;

%%*** BLOC EXTERIEUR (DSGE CANONIQUE)                                                                                            
YS-hs*YS(-1)=(YS(1)-hs*YS)-(1/sig)*(1-hs)*(IRS-PIS)+epsYS-covid1*COVID19;														%%(10)
PIS-delta*PIS(-1)=(1-thetaS)*(1-beta*thetaS)*lamdaS*YS+beta*(PIS(1)-delta*PIS)+epsIS;											%%(11)
IRS=khiS*IRS(-1)+(1-khiS)*(phipiS*(PIS-PISss)+phiyS*YS)+epsIRS;																%%(12)

%% MENAGES
CR=(1/(1+h))*(CR(1)-h*CR(-1))-(1/sig)*((1-h)/(1+h))*(IB-PI(1)+(1/(1+TAXCss))*(TAXC-TAXC(1)))-covid2*COVID19+epsCR;			%%Euler de la consommation des Ricardiens 	(17)
(1+TAXCss)*(CNRss/Yss)*CNR=(Wss*Nss/Yss)*(TAXW+(1-TAXWss)*(W+N))-(CNRss/Yss)*TAXC-covid3*COVID19+epsCNR;					%%Consommation Non Ricardiens              	(18)
C=(1-m)*(CRss/Css)*CR+m*(CNRss/Css)*CNR;																				%%Consommation agrge                      (19)                                     
MH=(1/sig)*C-(beta/(1-beta))*IB;                          															%%Demande de monnaie (19)
D=(1/sig)*C+((1+IDss)/(IBss-IDss))*(ID-IB);            															%%Dynamique des dpts auprs des banques 	(20)
N=(W-(C/sig))*(etaN*(Css)^(1/sig))/(Wss-etaN*(Css)^(1/sig))-covid6*COVID19+epsN; 												%%Offre de travail 							(21)
N=tau*NI+(1-tau)*NO;                                                        											%% Offre de travail agrge					(22)

% INTERMEDIATE GOODS FIRM

NI=K-kappaW*IC-W+((1+beta*delta)/(1+beta*delta-beta))*RK;                                     //Demande de travail (5)
PIH=((theta-1)/phi_F)*MC+beta*PIH(1); //Courbe de Phillips forward looking (7)
%PI=((1-ksi)*(1-ksi*beta)/ksi)*MC+beta*PI(1);
MC=(1-alpha)*(kappaW*IC+W)+((alpha+alpha*beta*delta)/(1+beta*delta-beta))*RK-A;              //Cout marginal (8)
YH=A+(1-alpha)*NI+alpha*K;                                                                     //Production (9)

% CAPITAL GOODS PRODUCER

K=(Iss/Kss)*I(-1)+(1-delta);                                    //Production de biens de capitaux (24)
%%RK(1)=((1+ILss)*(1+IBss)/(1+RKss))*(IB+IL-PI(1)+omicronK*(K(1)-K))-((1+ILss)/(1+RKss))*((1-delta)*IL(1)+omicronK*(K(2)-K(1)));     //Taux de location du capital(6)
RK=((1+ILss)*(1+IBss)/(1+RKss))*(IB(-1)+IL(-1)-PI+omicronK*(K-K(-1)))-((1+ILss)/(1+RKss))*((1-delta)*IL+omicronK*(K(1)-K)); 

%%*** SECTEUR PETROLIER

KO=(1-deltaO)*KO(-1)+alphaO*deltaO*(YOss/KOss)*(PO+YO); 				%%Dynamique du capital dans le secteur petrolier			%%(13)
YO=AO+gammaO*K(-1)+(1-gammaO)*NO;										%%Fonction de production du secteur petrolier				%%(14)
NO=((1-alphaO)*(1-gammaO)*POss*YOss*(PO+YO-WO))/(NOss*WOss); %%Dynamique de l'emploi dans le secteur petrolier						%%(15)
PO=rhoPO*PO(-1)+(1-rhoPO)*POss-covid5*COVID19+epsPO;   								%%Cours du baril de ptrole							%%(16)
AO=rhoAO*AO(-1)+(1-rhoAO)*AOss+epsAO;																								%%(17)								


% COMMERCIAL BANK

MUTR=(MUss*MU/MUTRss)-((1+IRss)*IR/(phiC2*MUTRss));            																			//Ratio de reserves totales (10)
MUER=-(1+IRss)*IR/phiC2*MUERss;                                																			//Ratio de reserves excedentaires (11)
ERTR=(MUTR/ERTRss)-(MUss*MU/MUTRss*ERTRss)-MUTR;              																			// Ratio exces de reserves sur reserves totales (12)
TR=(1/TRss)*((MU+D)*MUss*Dss+(MUER+D)*MUERss*Dss);             																			//Reserves totales (13)
ID=(1/(1+IDss))*(1+1/etaD)^(-1)*((1-MUTRss)*(1+IRss)*IR-MUTRss*MUTR*(IRss-IMss)+(phiC1-phiC2*(MUTRss-MUss))*(MUTRss*MUTR-MUss*MU));     //Taux sur depots (14)
IL=IC-QF;                                                      																			//Taux sur les prets (15)
QF=phi2*Y+phi1*(K-LFI);                                        																			//Probabilite de remboursement (16)
CL=K-LFI+epsCL;                                                      																	// Ratio collateral sur prets (17)
LFW=N+W;                                                       																			// Prets aux firmes intermediaires (19)
LFI=I;                                                         																			//Demande de credit des producteurs de biens de capitaux (20)
LF=(kappaW*Wss*Nss/LFss)*(N+W)+(Iss*I/LFss);                   																			//Prets total aux firmes (21)
MHss*MH+Dss*D=0;                                               																			//Equilibre du marche monetaire (23)

% GOVERNMENT

%%Tss*T-Gss*G=IMss*TRss*(TR(-1)-PI)+(IBss*BCss-(1+IBss)*Bss)*PI+(1+IBss)*(Bss-BCss)*IB(-1)-LBss*(1+IRss)*IR(-1)-IRss*LBss*(LB(-1)-PI);       							//Taxes (26)

Bss*(1+B)+Tss*(1+T)+((ICss*LBss)/(1+PIss))*(IC+LB-PI)-(IMss*TRss*(IM+TR(-1)-PI)/(1+PIss))=Gss*(1+G)+((1+IBss)*Bss/(1+PIss))*(1+IB+B-PI);

Bss*(1+B)=BCss*(1+BC)+BHss*(1+BH)+BSss*(1+BS);
BS=rhoBS*BS(-1)+epsBS;
BH=rhoBH*BH(-1)+epsBH;
G=phi*Y+covid7*COVID19+epsG;
TAXC=rhotaxc*TAXC(-1)-txc*COVID19(-1)+epsTAXC; 																																				%%Taxes sur la consommation (59)
TAXW=rhotaxw*TAXW(-1)-txw*COVID19(-1)+epsTAXW;
T=m*(TAXCss/Tss)*TAXC+(1-m)*(TAXWss/Tss)*TAXW;

% CENTRAL BANK

IR=khi*IR(-1)+(1-khi)*(phipi*(PI-PIss)+phiy*Y+phiER*ERTR)+epsIR;              		//Regle monetaire (18)
MU=rhoMU*MU(-1)+phiER1*ERTR+epsMU;                                            		//Regle reserves obligatoires
1+THETAB=theta0*((LBss/Dss)*(1+LB-D))+epsTHETAB;                               		//Penalite sur les emprunts Banque centrale
(ICss/(1+ICss))*IC=(IRss/(1+IRss))*IR+(THETABss/(1+THETABss))*THETAB;         		//Plafond du corridor des taux de la Banque centrale
LB=(LFss*LF/LBss)-(Dss/LBss)*(D-MUTRss*D-MUTRss*MUTR);        				 		//Emprunts a la banque centrale (22)
BCss*(1+BC)+LBss*(1+LB)=TRss*(1+TR)+MHss*(1+MH);									//Bilan de la banque centrale
%%AEX=rhoAEX*AEX(-1)+PO*YO-alphaPHI*YS;
AEX=rhoAEX*AEX(-1)+(POss*YOss/AEXss)*(PO+YO)-alphaPHI*YS/AEXss;
TCE=(AEXss*MHss/TCEss)*(AEX-MH);

% Equillibre symetrique
%%Yss*Y*(1-phi)=Css*C+delta*Kss*I;                                   				//Equilibre du marche des biens (25)
Y=tau*YH+(1-tau)*YO;
BCss*(1+BC)=MHss*(1+MH)+Dss*(1+D);

% PROCESSUS STOCHASTIQUES
A=rhoA*A(-1)+epsA;
COVID19=rhoCOVID19*COVID19(-1)+epsCOVID19;	%%Choc COVID-19 s'tant traduit par des dcs, des confinements puis des pertes d'emplois


end;


initval;
C=0; IB=0; PI=0; MH=0; N=0; NI=0; W=0; K=0; IR=0; RK=0; IL=0; MC=0; Y=0; A=0; MUTR=0; MU=0; TR=0; MUER=0; QF=0; LFI=0; CL=0; LFW=0; I=0; LF=0; LB=0; B=0; IM=0; BC=0; BH=0; CR=0; CNR=0; TAXC=0; TAXW=0; COVID19=0;
PHI=0; Q=0; S=0; PIF=0; PIH=0; IRS=0; PIS=0; YS=0; KO=0; NO=0; WO=0; YO=0; PO=0; AO=0; AEX=0; TCE=0;

end;

steady;

check;

shocks;

var epsIR; stderr 0.25;
var epsCR; stderr 0.1;
var epsCNR; stderr 0.1;
var epsN; stderr 0.1;
var epsPO; stderr 0.1;
var epsPIF; stderr 0.1;
var epsS; stderr 0.1;
var epsYS; stderr 0.1;
var epsCL; stderr 0.1;
var epsG; stderr 0.1;
var epsTAXC; stderr 0.1;
var epsTAXW; stderr 0.1;
var epsBH; stderr 0.1;
var epsBS; stderr 0.1;
var epsMU; stderr 0.1;
var epsTHETAB; stderr 0.1;



%var epsA; stderr 0.1;
%var epsTAXC; stderr 0.1;
%var epsTAXW; stderr 0.1;
%var epsBH; stderr 0.1;
%var epsBS; stderr 0.1;
%var epsAO; stderr 0.1;
%var epsS; stderr 0.1;
%var epsQ; stderr 0.1;


end;

stoch_simul(order=1,irf=40,nograph) Y CR CNR PI T G S TCE IR THETAB QF IL LF LB ERTR CL YH YO YS;
      