%% Reactions aux chocs dans la CEMAC sans et avec COVID-19

clear
clc
close all

dynare covids00.mod
    load('covids00_results.mat', 'oo_')
    irf_1=oo_.irfs;
    save irf_1
    dynare covids01.mod noclearall
    load('covids01_results.mat', 'oo_')
    irf_2=oo_.irfs;
    save irf_2
    load irf_1
    load irf_2
    ending_cell={'_epsPO','_epsCL','_epsPIF','_epsCR','_epsCNR','_epsYS','_epsN'};
    for ii=1:length(ending_cell)
HOR=0:1:39;
var={'Y','CR','CNR','PI','T','G','S','TCE','IR','THETAB','QF','IL','LF','LB','ERTR','CL'};
figure
for jj=1:length(var)
subplot(4,4,jj)
eval(['irf_1.' var{1,jj},ending_cell{1,ii}]);
eval(['irf_2.' var{1,jj},ending_cell{1,ii}]);
plot(HOR,eval(['irf_1.' var{1,jj},ending_cell{1,ii}]),'LineWidth',5);
hold on
plot(HOR,eval(['irf_2.' var{1,jj},ending_cell{1,ii}]),'LineWidth',5);
grid;
title(['Reponse de  ',var{1,jj},'  Au choc  ',ending_cell{1,ii}] )
legend('Sans Covid19','Avec Covid19')
xlabel('Trimestres');
ylabel('IRFs');
end
    end

%% Recul de la croissance de 2.9% au bout d-un an (5,5 % pour YO et 2,3 % pour YH)

clc

load('covids01_results.mat', 'oo_')
irf_2fs=oo_.irfs;
    save irf_2fs

    growth=(Y_epsCOVID19(1:4));
    G=sum(growth);
    
% Recul croissance secteur hors petrole 2.3% environ au bout d'un an
    growthH=(YH_epsCOVID19(1:4));
    GH=sum(growthH);

% Recul de la croissance secteur petrolier 5.5% environ au bout d'un an
    growthO=(YO_epsCOVID19(1:4));
    GO=sum(growthO);
    
% Recul de la croissance etrangere de 4.4% environ
    growthS=(YS_epsCOVID19(1:4));
    GS=sum(growthS);

% Tensions inflationnistes (2.7)
    inflation=(PI_epsCOVID19(1:4));
    INF=sum(inflation);

% Creusement des deficits publics de 2.5% environ
    ET=(T_epsCOVID19(1:4));
    ST=sum(ET);
    EG=(G_epsCOVID19(1:4));
    SG=sum(EG);
    TG=ST-SG;

% Degradation des termes de l-echange de 21% environ au bout d-un an
    tdr=(S_epsCOVID19(1:4));
    TDR=sum(tdr);

% degradation du collateral de 2% environ
    col=(CL_epsCOVID19(1:4));
    COL=sum(col);


%% Impact COVID-19 vs mesures budgetaire et monetaire puis efficiacite comparee

clear
clc
close all

dynare covids01c.mod
    load('covids01c_results.mat','oo_')
    irf_5d=oo_.irfs;
    save irf_5d

dynare covids02.mod
    load('covids02_results.mat', 'oo_')
    irf_6d=oo_.irfs;
    save irf_6d
    
dynare covids03.mod noclearall
    load('covids03_results.mat', 'oo_')
    irf_7d=oo_.irfs;
    save irf_7d
    load irf_5d
    load irf_6d
    ending_cell={'_epsIR','_epsMU','_epsTHETAB','_epsCL','_epsBH', '_epsBS','_epsTAXC','_epsTAXW','_epsG','_epsCOVID19'};
    for ii=1:length(ending_cell)
HOR=0:1:39;
var={'Y','CR','CNR','PI','T','G','S','TCE','IR','THETAB','QF','IL','LF','LB','ERTR','CL'};
figure
for jj=1:length(var)
subplot(4,4,jj)
eval(['irf_5d.' var{1,jj},ending_cell{1,ii}]);
eval(['irf_6d.' var{1,jj},ending_cell{1,ii}]);
eval(['irf_7d.' var{1,jj},ending_cell{1,ii}]);
plot(HOR,eval(['irf_5d.' var{1,jj},ending_cell{1,ii}]),'LineWidth',5);
hold on
plot(HOR,eval(['irf_6d.' var{1,jj},ending_cell{1,ii}]),'LineWidth',5);
hold on
plot(HOR,eval(['irf_7d.' var{1,jj},ending_cell{1,ii}]),'LineWidth',5);
grid;
title(['Reponse de  ',var{1,jj},'  Au choc  ',ending_cell{1,ii}] )
legend('Impact covid19','Mesures budgetaires','Mesures monetaires')
xlabel('Trimestres');
ylabel('IRFs');
end
    end